let video_handler_initialized = false;


$(document).ready(function() {
    let video_overlay = browser.storage.sync.get(['video_overlay','user','active']);
    video_overlay.then((res) => {
        if(res.active && res.user && res.user.permissions.permission_video_overlay <= res.user.patreon_tier) {
            let use_overlay = res.video_overlay || false;
            if (use_overlay) {
                if (!video_handler_initialized) {
                    video_handler_initialized = true;
                    canvasScan();
                }
            }
        }
    });
});


window.addEventListener('load', function () {
    let video_overlay = browser.storage.sync.get(['video_overlay','user','active']);
    video_overlay.then((res) => {
        if(res.active && res.user && res.user.permissions.permission_video_overlay <= res.user.patreon_tier) {
            let use_overlay = res.video_overlay || false;
            if (use_overlay) {
                if (!video_handler_initialized) {
                    video_handler_initialized = true;
                    canvasScan();
                }
            }
        }
    });
})


/*
$(document).on ('mozfullscreenchange webkitfullscreenchange fullscreenchange',function(event){
    let target = event.target;
    if($(target).attr("puryfied")){
        let uuid = $(target).attr("puryfied");
        exitFullscreen();
        let canvas = $( 'canvas[puryfied="'+uuid+'"]' ).first();
        launchIntoFullscreen(canvas);
    }
});

function launchIntoFullscreen(element) {
    if (element.requestFullscreen) {
        element.requestFullscreen();
    } else if (element.mozRequestFullScreen) {
        element.mozRequestFullScreen();
    } else if (element.webkitRequestFullscreen) {
        element.webkitRequestFullscreen();
    } else if (element.msRequestFullscreen) {
        element.msRequestFullscreen();
    }
}

function exitFullscreen() {
    if (document.exitFullscreen) {
        document.exitFullscreen();
    } else if (document.mozCancelFullScreen) {
        document.mozCancelFullScreen();
    } else if (document.webkitExitFullscreen) {
        document.webkitExitFullscreen();
    }
}
*/
function canvasScan(){
    $( "canvas[puryfied]" ).each(function() {
        let uuid = $(this).attr('puryfied');
        let r = $( 'video[puryfied="'+uuid+'"]' );
        if(r.length == 0 || !r.is(':visible')){
            r.removeAttr('puryfied');
            $(this).remove();
        }
    });
    $( "video:not([puryfied])" ).each(function() {

        if(!content_handler_initialized){
            content_handler_initialized = true;
            initStorageData();
        }

        canvasCreate(this);
        return;
    });
    setTimeout(() => {
        canvasScan();
    }, 100);
}

function canvasCreate(video){
    let uuid = '_' + Math.random().toString(36).substr(2, 9)
    $( video ).attr('puryfied', uuid);
    $( video ).attr('controls', 'controls');
    let c1 = document.createElement("canvas");
    let c2 = document.createElement("canvas");
    $( c1 ).attr('puryfied', uuid);
    //$( video ).parent().prepend(c1);
    $( c1 ).insertBefore($( video ));

    const processor = {};

    processor.readjustSize = function readjustSize() {
        //var fullscreenElement = document.fullscreenElement || document.mozFullScreenElement ||
        //    document.webkitFullscreenElement || document.msFullscreenElement;
        //if(!fullscreenElement){
        let styles = document.defaultView.getComputedStyle(this.video, "");
        const cssText = Object.values(styles).reduce(
            (css, propertyName) =>
                `${css}${propertyName}:${styles.getPropertyValue(
                    propertyName
                )};`
        );
        this.c1.style.cssText = cssText;

        //}
        this.c1.style.background = 'none';
        this.c1.style.pointerEvents = 'none';
        this.c1.style.position = 'absolute';
        this.c1.style.zIndex = '2147483647';

    }

    processor.doLoad = function doLoad(elem, c1, c2) {
        this.latest_result = null;
        this.latest_result_frame = null;
        const video = elem;
        this.video = video;
        this.c1 = c1;
        this.ctx1 = this.c1.getContext('2d');
        this.c2 = c2;
        this.ctx2 = this.c2.getContext('2d');
        this.frame_cache = {};

        this.readjustSize();
        video.addEventListener('play', () => {
            //this.width = video.videoWidth;
            //this.height = video.videoHeight;
            this.timerCallback();
        }, false);

        const isVideoPlaying = !!(video.currentTime > 0 && !video.paused && !video.ended && video.readyState > 2);

        if(!isVideoPlaying){
            this.timerCallback();
        }
    };

    processor.timerCallback = function timerCallback() {
        if (this.video.paused || this.video.ended) {
            return;
        }

        this.readjustSize();
        this.computeFrame().then(r => {
            setTimeout(() => {
                this.timerCallback();
            }, 0);
        });

    };

    processor.computeFrame = function computeFrame() {
        return new Promise((resolve, reject) => {
            this.c1.width = this.video.offsetWidth;
            this.c1.height = this.video.offsetHeight;
            /*
            let tempCanvas = document.createElement('canvas');
            tempCanvas.width = this.c1.width;
            tempCanvas.height = this.c1.height;
            let tempCtx = tempCanvas.getContext('2d');
            tempCtx.drawImage(this.video, 0, 0, this.video.offsetWidth, this.video.offsetHeight);
            let frame = tempCtx.getImageData(0, 0, this.video.offsetWidth, this.video.offsetHeight);
             */
            this.c2.width = this.video.offsetWidth;
            this.c2.height = this.video.offsetHeight;
            this.ctx2.drawImage(this.video, 0, 0, this.video.offsetWidth, this.video.offsetHeight);
            let frame = this.ctx2.getImageData(0, 0, this.video.offsetWidth, this.video.offsetHeight);

            if (this.latest_result != null) {
                let video_handler_options = browser.storage.sync.get(['file_types','labels','censor_type',
                    'bar_configuration','blur_configuration','pixel_configuration','gif_configuration',
                    'glitch_configuration','triangle_configuration','sticker_configuration','reverse_mode_configuration','clustering_configuration']);
                video_handler_options.then((res) => {
                    labels = res.labels;
                    censor_type = res.censor_type;
                    file_types = res.file_types;
                    blur_configuration  = res.blur_configuration;
                    bar_configuration   = res.bar_configuration;
                    pixel_configuration = res.pixel_configuration;
                    glitch_configuration = res.glitch_configuration;
                    triangle_configuration = res.triangle_configuration;
                    sticker_configuration = res.sticker_configuration;
                    gif_configuration 	= res.gif_configuration;
                    reverse_mode_configuration = res.reverse_mode_configuration;
                    clustering_configuration = res.clustering_configuration;
                });
                let marvinImage = new MarvinImage();
                /*
                let fresh = document.createElement('canvas');
                fresh.width = this.c1.width;
                fresh.height = this.c1.width;
                const fresh_ctx = fresh.getContext('2d');
                */
                this.ctx1.putImageData(this.latest_result_frame, 0,0);

                marvinImage.width = this.c1.width;
                marvinImage.height = this.c1.height;

                marvinImage.canvas = this.c1;//this.latest_result_canvas;//this.c1
                marvinImage.ctx = this.ctx1;//this.latest_result_ctx;//this.ctx1;

                marvinImage.imageData = this.latest_result_frame;

                //If we remove this line it has a swing back on black box and box
                //marvinImage.update();
                let conf = {
                    bar_configuration: bar_configuration,
                    pixel_configuration: pixel_configuration,
                    blur_configuration: blur_configuration,
                    glitch_configuration: glitch_configuration,
                    triangle_configuration: triangle_configuration,
                    sticker_configuration: sticker_configuration,
                    reverse_mode_configuration: reverse_mode_configuration,
                    sticker_collections: sticker_collections,
                };

                let data = [this.latest_result.valid_detections, this.latest_result.classes, this.latest_result.scores, this.latest_result.boxes];
                let outer = this;

                if(this.latest_result && censor_type === "triangle"
                    || (censor_type === "sticker" && !conf.sticker_collections)
                ){
                    /* This code is not really working (laggy)
                    marvinImage.canvas.toBlob(function(blob) {
                        let paint_request = browser.runtime.sendMessage({
                            paint_request: true,
                            data: data,
                            blob: blob,
                        });
                        paint_request.then(paint_response => {
                            const img = new Image()
                            img.onload = (event) => {
                                URL.revokeObjectURL(event.target.src);
                                outer.ctx1.drawImage(event.target, 0,0);
                            }
                            img.src = URL.createObjectURL(paint_response.blob);
                        });
                    });
                    */
                }else {

                    paintCensor(marvinImage, censor_type, labels,
                        this.latest_result.valid_detections,
                        this.latest_result.classes,
                        this.latest_result.scores,
                        this.latest_result.boxes,
                        conf,
                        this.frame_cache
                    );
                    //let t1 = performance.now();
                    this.ctx1.drawImage(marvinImage.canvas, 0,0, marvinImage.width, marvinImage.height);
                    //this.ctx1.putImageData(marvinImage.imageData, 0, 0);
                }

            }

            let sending = browser.runtime.sendMessage({
                ai_request: true,
                frame: frame,
                width: this.video.offsetWidth,
                height: this.video.offsetHeight
            });
            sending.then(response => {
                    let valid_detections = response.valid_detections;
                    let classes = response.classes;
                    let scores = response.scores;
                    let boxes = response.boxes;
                    this.latest_result_frame = frame;

                    this.latest_result = {
                        valid_detections: valid_detections,
                        classes: classes,
                        scores: scores,
                        boxes: boxes,
                    };
                }
                , handleError2).finally(fin => {
                resolve();
            });
        });
    };

    processor.doLoad(video, c1, c2);
}


function handleError2(error) {
    console.log(`Error: ${error}`);
}

/*
function simulate(element, eventName)
{
    var options = extend(defaultOptions, arguments[2] || {});
    var oEvent, eventType = null;

    for (var name in eventMatchers)
    {
        if (eventMatchers[name].test(eventName)) { eventType = name; break; }
    }

    if (!eventType)
        throw new SyntaxError('Only HTMLEvents and MouseEvents interfaces are supported');

    if (document.createEvent)
    {
        oEvent = document.createEvent(eventType);
        if (eventType == 'HTMLEvents')
        {
            oEvent.initEvent(eventName, options.bubbles, options.cancelable);
        }
        else
        {
            oEvent.initMouseEvent(eventName, options.bubbles, options.cancelable, document.defaultView,
                options.button, options.pointerX, options.pointerY, options.pointerX, options.pointerY,
                options.ctrlKey, options.altKey, options.shiftKey, options.metaKey, options.button, element);
        }
        element.dispatchEvent(oEvent);
    }
    else
    {
        options.clientX = options.pointerX;
        options.clientY = options.pointerY;
        var evt = document.createEventObject();
        oEvent = extend(evt, options);
        element.fireEvent('on' + eventName, oEvent);
    }
    return element;
}

function extend(destination, source) {
    for (var property in source)
        destination[property] = source[property];
    return destination;
}

var eventMatchers = {
    'HTMLEvents': /^(?:load|unload|abort|error|select|change|submit|reset|focus|blur|resize|scroll)$/,
    'MouseEvents': /^(?:click|dblclick|mouse(?:down|up|over|move|out))$/
}
var defaultOptions = {
    pointerX: 0,
    pointerY: 0,
    button: 0,
    ctrlKey: false,
    altKey: false,
    shiftKey: false,
    metaKey: false,
    bubbles: true,
    cancelable: true
}
*/