document.addEventListener('DOMContentLoaded', restoreOptions);

let sticker_collections = null;

function restoreOptions() {
	$('#version').html(browser.runtime.getManifest().version);
	restoreONOFF();
	restoreLabels();
	restoreFiletypes();
	restoreCensorOptions();
	restoreCensorConfigs();
	restoreLoginState();
	restoreDebug();
	restoreAdvanced();
	restoreWhiteBlackList();
	updateHelp();
	restoreView();
}

function restoreLabels() {
	let labels = browser.storage.sync.get('labels');
	labels.then((res) => {
		$('.labelButton').each(function(i, obj) {
			if(res.labels.includes(obj.id)){
				$(this).addClass("selected");
				$('button[label='+$(this).attr('id')+']').attr('check', true);
				$('button[label='+$(this).attr('id')+']').parent().attr('check', true);
			}else{
				$(this).removeClass("selected");
				$('button[label='+$(this).attr('id')+']').removeAttr('check');
				$('button[label='+$(this).attr('id')+']').parent().removeAttr('check');
			}
		});
	});
}

function restoreFiletypes() {
	let file_types = browser.storage.sync.get('file_types');
	file_types.then((res) => {
		$('.filetypeToogle').each(function(i, obj) {
			if(res.file_types.includes($(this).attr('label'))){
				$(this).attr('check', true);
			}else{
				$(this).removeAttr('check');
			}
		});
	});
}

function restoreCensorOptions() {
	let censor_type = browser.storage.sync.get(['censor_type']);
	censor_type.then((res) => {
		$('.censormodeToogle').each(function(i, obj) {
			if(res.censor_type.includes($(this).attr('label'))){
				$(this).attr('check', true);
				$("#"+$(this).attr('label')).addClass("selected");
			}else{
				$(this).removeAttr('check');
			}
		});
		//$('#bar_colorpicker').attr('value', (res.bar_color));
	});

}

function restoreLoginState(){
	let user_req = browser.storage.sync.get(['user', 'username', 'password']);
	user_req.then((res) => {
		if(res.user){
			loginSuccess(res.user);
		}else{
			if(res.username){
				$("#profile_name").html(res.username);
				$("#profile_tier").html(res.password || '');
			}
			$("#login_form :input").prop("disabled", false);
			$("#login_form").show("slow");
			$("#profile").hide();
		}
	});
}

function restoreDebug() {
	let debug = browser.storage.sync.get('debug');
	debug.then((res) => {
		$('.debugToogle').each(function(i, obj) {
			if(res.debug){
				$(this).attr('check', true);
				$('#'+$(this).attr('label')).addClass("selected");
			}else{
				$(this).removeAttr('check');
				$('#'+$(this).attr('label')).removeClass("selected");
			}

		});
	});
}

function restoreCensorConfigs() {
	let censor_type = browser.storage.sync.get(['bar_configuration','blur_configuration','pixel_configuration',
		'glitch_configuration','triangle_configuration','sticker_configuration',
		'gif_configuration','png_configuration', 'jpg_configuration', 'bmp_configuration', 'webp_configuration',
		'reverse_mode_configuration','clustering_configuration']);
	censor_type.then((res) => {
		$('#bar_colorpicker').attr('value', (res.bar_configuration._color));
		$('#bar_scale').val(res.bar_configuration._scale);
		$('#bar_shape').val(res.bar_configuration._shape);
		$('#bar_feathering').val(res.bar_configuration._feathering);

		$('#blur_scale').val(res.blur_configuration._scale);
		$('#blur_feathering').val(res.blur_configuration._feathering);
		$('#blur_strength').val(res.blur_configuration._blur_strength);
		$('#blur_shape').val(res.blur_configuration._shape);

		$('#pixel_geometry').val(res.pixel_configuration._geometry);
		$('#pixel_scale').val(res.pixel_configuration._scale);
		$('#pixel_feathering').val(res.pixel_configuration._feathering);
		$('#pixel_distance').val(res.pixel_configuration._distance);
		$('#pixel_size').val(res.pixel_configuration._pixel_size);
		$('#pixel_size_mode').val(res.pixel_configuration._pixel_size_mode);
		$('#pixel_shape').val(res.pixel_configuration._shape);

		if($('#pixel_size_mode').val() == 0){
			$('#pixel_size_suffix').val('%');
		}else{
			$('#pixel_size_suffix').val('px');
		}
		$('#glitch_intensity_color').val(res.glitch_configuration.intensity_color);
		$('#glitch_intensity_shift').val(res.glitch_configuration.intensity_shift);
		$('#glitch_scale').val(res.glitch_configuration._scale);
		$('#glitch_horizontal_shift').prop('checked', res.glitch_configuration.shift_horizontal);
		$('#glitch_vertical_shift').prop('checked', res.glitch_configuration.shift_vertical);

		$('#triangle_scale').val(res.triangle_configuration._scale);
		$('#triangle_shape').val(res.triangle_configuration._shape);
		$('#triangle_feathering').val(res.triangle_configuration._feathering);
		$('#triangle_accuracy').val(res.triangle_configuration.accuracy);
		$('#triangle_blur').val(res.triangle_configuration.blur);
		$('#triangle_threshold').val(res.triangle_configuration.threshold);
		if(res.triangle_configuration.vertexMode){
			$('#triangle_vertex_mode_dynamic').prop('checked', true);
			$('.triangle_vertex_count_static').hide();
			$('.triangle_vertex_count_dynamic').show();
		}else{
			$('#triangle_vertex_mode_static').prop('checked', true);
			$('.triangle_vertex_count_dynamic').hide();
			$('.triangle_vertex_count_static').show();
		}
		$('#triangle_vertex_count_static').val(res.triangle_configuration.vertexCount);
		$('#triangle_vertex_count_dynamic').val(res.triangle_configuration.vertexPercentage);
		if(res.triangle_configuration.fill === true){
			$('#triangle_fill_on').prop('checked', true);
		}else if(res.triangle_configuration.fill === false){
			$('#triangle_fill_off').prop('checked', true);
		}else{
			$('#triangle_fill_color').prop('checked', true);
		}
		$('#triangle_fill_colorpicker').attr('value', (res.triangle_configuration.fillColor));

		if(res.triangle_configuration.stroke === true){
			$('#triangle_stroke_on').prop('checked', true);
		}else if(res.triangle_configuration.stroke === false){
			$('#triangle_stroke_off').prop('checked', true);
		}else{
			$('#triangle_stroke_color').prop('checked', true);
		}
		$('#triangle_stroke_colorpicker').attr('value', (res.triangle_configuration.strokeColor));
		$('#triangle_stroke_width').val(res.triangle_configuration.strokeWidth);

		$('#triangle_gradient').prop('checked', res.triangle_configuration.gradients);
		$('#triangle_gradient_stops').val(res.triangle_configuration.gradientStops);
		$('#triangle_line_join').val(res.triangle_configuration.lineJoin);
		$('#triangle_transparent_color').prop('checked', res.triangle_configuration.transparentColor);

		$('#sticker_scale').val(res.sticker_configuration._scale);
		$('#sticker_draw_mode').val(res.sticker_configuration._draw_mode);
		$('#sticker_groups').val(res.sticker_configuration._groups.join(';'));
		$('#sticker_consistency').prop('checked', res.sticker_configuration._consistency);
		$('#sticker_draw_mode').trigger('change');

		$('#gif_memory_mode').val(res.gif_configuration._memory_method);
		if(res.gif_configuration._thumbnails){
			$('#gif_thumb').attr('check', true);
			$('#gif_thumb_button').attr('check', true);
		}else{
			$('#gif_thumb').removeAttr('check');
			$('#gif_thumb_button').removeAttr('check');
		}
		$('#png_min_file_size').val(res.png_configuration._filesize_min/1000);
		$('#png_max_file_size').val(res.png_configuration._filesize_max/1000);
		$('#png_min_width').val(res.png_configuration._width_min);
		$('#png_max_width').val(res.png_configuration._width_max);
		$('#png_min_height').val(res.png_configuration._height_min);
		$('#png_max_height').val(res.png_configuration._height_max);
		//res.webp_configuration._file_output_type = document.querySelector('input[name="webp_file_output"]:checked').value;
		$('input[type="radio"][name="png_file_output"][value="'+res.png_configuration._file_output_type+'"]').prop('checked', true);

		$('#jpg_min_file_size').val(res.jpg_configuration._filesize_min/1000);
		$('#jpg_max_file_size').val(res.jpg_configuration._filesize_max/1000);
		$('#jpg_min_width').val(res.jpg_configuration._width_min);
		$('#jpg_max_width').val(res.jpg_configuration._width_max);
		$('#jpg_min_height').val(res.jpg_configuration._height_min);
		$('#jpg_max_height').val(res.jpg_configuration._height_max);
		$('input[type="radio"][name="jpg_file_output"][value="'+res.jpg_configuration._file_output_type+'"]').prop('checked', true);


		$('#bmp_min_file_size').val(res.bmp_configuration._filesize_min/1000);
		$('#bmp_max_file_size').val(res.bmp_configuration._filesize_max/1000);
		$('#bmp_min_width').val(res.bmp_configuration._width_min);
		$('#bmp_max_width').val(res.bmp_configuration._width_max);
		$('#bmp_min_height').val(res.bmp_configuration._height_min);
		$('#bmp_max_height').val(res.bmp_configuration._height_max);
		$('input[type="radio"][name="bmp_file_output"][value="'+res.bmp_configuration._file_output_type+'"]').prop('checked', true);

		$('#webp_min_file_size').val(res.webp_configuration._filesize_min/1000);
		$('#webp_max_file_size').val(res.webp_configuration._filesize_max/1000);
		$('#webp_min_width').val(res.webp_configuration._width_min);
		$('#webp_max_width').val(res.webp_configuration._width_max);
		$('#webp_min_height').val(res.webp_configuration._height_min);
		$('#webp_max_height').val(res.webp_configuration._height_max);
		$('input[type="radio"][name="webp_file_output"][value="'+res.webp_configuration._file_output_type+'"]').prop('checked', true);

		$('#gif_min_file_size').val(res.gif_configuration._filesize_min/1000);
		$('#gif_max_file_size').val(res.gif_configuration._filesize_max/1000);
		$('#gif_min_width').val(res.gif_configuration._width_min);
		$('#gif_max_width').val(res.gif_configuration._width_max);
		$('#gif_min_height').val(res.gif_configuration._height_min);
		$('#gif_max_height').val(res.gif_configuration._height_max);
		$('#gif_max_frame_count').val(res.gif_configuration._frame_count_max);
		$('#gif_thumbnail_fallback').prop('checked', res.gif_configuration._thumbnail_fallback);

		if(res.reverse_mode_configuration.enabled){
			$('.reverse_censoring').attr('check', true);
		}else{
			$('.reverse_censoring').removeAttr('check');
		}
		if(res.reverse_mode_configuration.process_no_result){
			$('#reverse_censoring_process_no_results').prop('checked', true);//.attr('check', true);
		}else{
			$('#reverse_censoring_process_no_results').prop('checked', false);//.removeAttr('check');
		}


		$('.clusteringToogle').each(function(i, obj) {
			if(res.clustering_configuration.enabled){
				$(this).attr('check', true);
			}else{
				$(this).removeAttr('check');
			}
		});


		$('#clustering_mode').val(res.clustering_configuration.mode);

		$('.file_max_min').trigger('paste');
		$('.zero_look_disabled').trigger('paste');
	});
	let sticker_request = browser.storage.local.get(['sticker_collections']);
	sticker_request.then((res) => {
		sticker_collections = res.sticker_collections;
		$('#sticker_collections').empty();
		res.sticker_collections.forEach(function(collection, key){
			$('#sticker_collections').append($('<option>', {
				value: key,
				text: capitalizeFirstLetter(collection._name),
				name: collection._name,
				class: ' '+(collection._enabled? 'sticker_collection_enabled': 'sticker_collection_disabled')+
					' '+(collection._locked? 'sticker_collection_locked': ''),
			}));
		});
	});
}


function restoreAdvanced() {
	let advanced = browser.storage.sync.get(['video_overlay', 'base64_scanner']);
	advanced.then((res) => {
		if(res.video_overlay){
			$('.video_overlay').attr('check', true);
		}else{
			$('.video_overlay').removeAttr('check');
		}
		if(res.base64_scanner){
			$('.base64_support').attr('check', true);
		}else{
			$('.base64_support').removeAttr('check');
		}
	});
}

function restoreWhiteBlackList() {
	let whiteblacklist = browser.storage.sync.get(['whiteblacklist_configuration']);
	whiteblacklist.then((res) => {
		if(res.whiteblacklist_configuration.mode == 0){
			$("#radio-nolist").prop("checked", true);
			$('#whitelist-container').hide();
			$('#blacklist-container').hide();
		}else if(res.whiteblacklist_configuration.mode == 1){
			$("#radio-whitelist").prop("checked", true);
			$('#whitelist-container').show();
			$('#blacklist-container').hide();
		}else{
			$("#radio-blacklist").prop("checked", true);
			$('#whitelist-container').hide();
			$('#blacklist-container').show();
		}
		$('#whitelist').val(res.whiteblacklist_configuration.white_list.join('\n'));
		$('#blacklist').val(res.whiteblacklist_configuration.black_list.join('\n'));
	});
}

function restoreView() {
	let option_page_view = browser.storage.sync.get(['option_page_view']);
	option_page_view.then((res) => {
		if(res.option_page_view){
			$('.tab[content='+res.option_page_view+']').click();
		}
	});
}

function updateHelp() {
	let cache = browser.storage.sync.get('do_cache');
	cache.then((res) => {
		$('.do_cacheToogle').each(function(i, obj) {
			if(res.do_cache){
				$(this).attr('check', true);
			}else{
				$(this).removeAttr('check');
			}
		});
	});
	let sending = browser.runtime.sendMessage({
		getdata: true
	});
	sending.then(function(message){
		$('#cached-count').html(message.cache.size);

		let mem = 0;
		message.cache.forEach(function(value, key, map){
			 mem += value._imgdata.size+roughSizeOfObject(value);
		});
		mem = formatBytes(mem);
		$('#cached-size').html(mem);

		/*
		$('#queue-count').html(message.queue.length);
		if(message.queue.length > 0){
			console.log(message.queue[0]);
		}
		*/

		//$('#queue-current').html(message.queue.length > 0?message.queue[0]:'');
	}, handleError);
}

$('#refresh-cache').click(function(){
	updateHelp();
});

$('#clear-cache').click(function(){
	let sending = browser.runtime.sendMessage({
		clearcache: true
	});
	sending.then(function(message){
		updateHelp();
	});
});

$('#pixel_geometry').change(function(){
	if($('#pixel_size_mode').val() == 1){
		if($('#pixel_geometry').val() == 1 || $('#pixel_geometry').val() == 2){
			if($('#pixel_size').val() < 5){
				$('#pixel_size').val(20);
			}
		}
	}
});

$('#pixel_size_mode').change(function(){
	if($('#pixel_size_mode').val() == 1){
		if($('#pixel_geometry').val() == 1 || $('#pixel_geometry').val() == 2){
			if($('#pixel_size').val() < 5){
				$('#pixel_size').val(20);
			}
		}
	}
});

$('.triangle_vertex_mode').change(function(){
	if($('#triangle_vertex_mode_dynamic').is(':checked')){
		$('.triangle_vertex_count_static').hide();
		$('.triangle_vertex_count_dynamic').show();
	}else{
		$('.triangle_vertex_count_dynamic').hide();
		$('.triangle_vertex_count_static').show();
	}
});

$('.file_max_min').on("change keyup paste", function(evt) {
	let trnslt = bytesToSize(this.value*1000);
	if(this.value == 0 && $(this).hasClass("max_file")){
		trnslt = "<b style='font-size: 120%'>∞</b>";
	}
	let linked = $(this).attr("link");
	$('.file_size_translated[link="'+linked+'"]').html(" = "+trnslt);
});

$('.zero_look_disabled').on("change keyup paste", function(evt) {
	if(this.value == 0){
		$(this).addClass( "look_disabled" );
	}else{
		$(this).removeClass( "look_disabled" );
	}
});

$('.save_config').change(function(){
	let conf = browser.storage.sync.get(['bar_configuration','blur_configuration','pixel_configuration',
		'gif_configuration','png_configuration', 'jpg_configuration', 'bmp_configuration', 'webp_configuration',
		'glitch_configuration','triangle_configuration', 'sticker_configuration',
		'whiteblacklist_configuration','clustering_configuration']);
	conf.then((res) => {
		res.bar_configuration._color =  $('#bar_colorpicker').val();
		res.bar_configuration._scale =   Math.max(0.1,parseFloat($('#bar_scale').val()));
		res.bar_configuration._shape =   Math.max(0,parseInt($('#bar_shape').val()));
		res.bar_configuration._feathering = Math.max(0,parseFloat($('#bar_feathering').val()));

		res.blur_configuration._scale =  Math.max(0.1,parseFloat($('#blur_scale').val()));
		res.blur_configuration._feathering = Math.max(0,parseFloat($('#blur_feathering').val()));
		res.blur_configuration._blur_strength = Math.max(2,parseInt($('#blur_strength').val()));
		res.blur_configuration._shape =   Math.max(0,parseInt($('#blur_shape').val()));


		res.pixel_configuration._geometry = $('#pixel_geometry').val();
		res.pixel_configuration._scale = Math.max(0.1,parseFloat($('#pixel_scale').val()));
		res.pixel_configuration._feathering = Math.max(0,parseFloat($('#pixel_feathering').val()));
		res.pixel_configuration._distance = Math.max(0,parseInt($('#pixel_distance').val()));
		res.pixel_configuration._pixel_size = Math.max(1,parseInt($('#pixel_size').val()));
		if($('#pixel_size_mode').val() == 0){
			$('#pixel_size_suffix').html('%');
		}else{
			$('#pixel_size_suffix').html('px');
		}
		res.pixel_configuration._pixel_size_mode = Math.max(0,parseInt($('#pixel_size_mode').val()));
		res.pixel_configuration._shape =   Math.max(0,parseInt($('#pixel_shape').val()));

		res.glitch_configuration._scale =  Math.max(0.1,parseFloat($('#glitch_scale').val()));
		res.glitch_configuration._feathering = Math.max(0,parseFloat($('#glitch_feathering').val()));
		res.glitch_configuration.intensity_color = Math.max(0,parseInt($('#glitch_intensity_color').val()));
		res.glitch_configuration.intensity_shift = Math.max(0,parseInt($('#glitch_intensity_shift').val()));
		res.glitch_configuration.shift_horizontal = $('#glitch_horizontal_shift').is(':checked');
		res.glitch_configuration.shift_vertical = $('#glitch_vertical_shift').is(':checked');
		res.gif_configuration._memory_method = Math.max(0,parseInt($('#gif_memory_mode').val()));

		res.sticker_configuration._scale =  Math.max(0.1,parseFloat($('#sticker_scale').val()));
		res.sticker_configuration._draw_mode =  Math.max(0,parseInt($('#sticker_draw_mode').val()));
		res.sticker_configuration._groups =  $('#sticker_groups').val().split(';');
		res.sticker_configuration._consistency = $('#sticker_consistency').is(':checked');

		res.png_configuration._height_max = Math.max(0,parseInt($('#png_max_height').val()? $('#png_max_height').val() : 0));
		res.png_configuration._height_min = Math.max(0,parseInt($('#png_min_height').val()? $('#png_min_height').val() : 0));
		res.png_configuration._width_max = Math.max(0,parseInt($('#png_max_width').val()? $('#png_max_width').val() : 0));
		res.png_configuration._width_min = Math.max(0,parseInt($('#png_min_width').val()? $('#png_min_width').val() : 0));
		res.png_configuration._filesize_max = Math.max(0,parseInt($('#png_max_file_size').val()? $('#png_max_file_size').val()*1000 : 0));
		res.png_configuration._filesize_min = Math.max(0,parseInt($('#png_min_file_size').val()? $('#png_min_file_size').val()*1000 : 0));
		res.png_configuration._file_output_type = document.querySelector('input[name="png_file_output"]:checked').value;

		res.jpg_configuration._height_max = Math.max(0,parseInt($('#jpg_max_height').val()? $('#jpg_max_height').val() : 0));
		res.jpg_configuration._height_min = Math.max(0,parseInt($('#jpg_min_height').val()? $('#jpg_min_height').val() : 0));
		res.jpg_configuration._width_max = Math.max(0,parseInt($('#jpg_max_width').val()? $('#jpg_max_width').val() : 0));
		res.jpg_configuration._width_min = Math.max(0,parseInt($('#jpg_min_width').val()? $('#jpg_min_width').val() : 0));
		res.jpg_configuration._filesize_max = Math.max(0,parseInt($('#jpg_max_file_size').val()? $('#jpg_max_file_size').val()*1000 : 0));
		res.jpg_configuration._filesize_min = Math.max(0,parseInt($('#jpg_min_file_size').val()? $('#jpg_min_file_size').val()*1000 : 0));
		res.jpg_configuration._file_output_type = document.querySelector('input[name="jpg_file_output"]:checked').value;

		res.bmp_configuration._height_max = Math.max(0,parseInt($('#bmp_max_height').val()? $('#bmp_max_height').val() : 0));
		res.bmp_configuration._height_min = Math.max(0,parseInt($('#bmp_min_height').val()? $('#bmp_min_height').val() : 0));
		res.bmp_configuration._width_max = Math.max(0,parseInt($('#bmp_max_width').val()? $('#bmp_max_width').val() : 0));
		res.bmp_configuration._width_min = Math.max(0,parseInt($('#bmp_min_width').val()? $('#bmp_min_width').val() : 0));
		res.bmp_configuration._filesize_max = Math.max(0,parseInt($('#bmp_max_file_size').val()? $('#bmp_max_file_size').val()*1000 : 0));
		res.bmp_configuration._filesize_min = Math.max(0,parseInt($('#bmp_min_file_size').val()? $('#bmp_min_file_size').val()*1000 : 0));
		res.bmp_configuration._file_output_type = document.querySelector('input[name="bmp_file_output"]:checked').value;

		res.webp_configuration._height_max = Math.max(0,parseInt($('#webp_max_height').val()? $('#webp_max_height').val() : 0));
		res.webp_configuration._height_min = Math.max(0,parseInt($('#webp_min_height').val()? $('#webp_min_height').val() : 0));
		res.webp_configuration._width_max = Math.max(0,parseInt($('#webp_max_width').val()? $('#webp_max_width').val() : 0));
		res.webp_configuration._width_min = Math.max(0,parseInt($('#webp_min_width').val()? $('#webp_min_width').val() : 0));
		res.webp_configuration._filesize_max = Math.max(0,parseInt($('#webp_max_file_size').val()? $('#webp_max_file_size').val()*1000 : 0));
		res.webp_configuration._filesize_min = Math.max(0,parseInt($('#webp_min_file_size').val()? $('#webp_min_file_size').val()*1000 : 0));
		res.webp_configuration._file_output_type = document.querySelector('input[name="webp_file_output"]:checked').value;

		res.gif_configuration._height_max = Math.max(0,parseInt($('#gif_max_height').val()? $('#gif_max_height').val() : 0));
		res.gif_configuration._height_min = Math.max(0,parseInt($('#gif_min_height').val()? $('#gif_min_height').val() : 0));
		res.gif_configuration._width_max = Math.max(0,parseInt($('#gif_max_width').val()? $('#gif_max_width').val() : 0));
		res.gif_configuration._width_min = Math.max(0,parseInt($('#gif_min_width').val()? $('#gif_min_width').val() : 0));
		res.gif_configuration._filesize_max = Math.max(0,parseInt($('#gif_max_file_size').val()? $('#gif_max_file_size').val()*1000 : 0));
		res.gif_configuration._filesize_min = Math.max(0,parseInt($('#gif_min_file_size').val()? $('#gif_min_file_size').val()*1000 : 0));
		res.gif_configuration._frame_count_max = Math.max(0,parseInt($('#gif_max_frame_count').val()? $('#gif_max_frame_count').val() : 0));
		res.gif_configuration._thumbnail_fallback = $('#gif_thumbnail_fallback').is(':checked');

		res.triangle_configuration._scale =   Math.max(0.1,parseFloat($('#triangle_scale').val()));
		res.triangle_configuration._shape =   Math.max(0,parseInt($('#triangle_shape').val()));
		res.triangle_configuration._feathering = Math.max(0,parseFloat($('#triangle_feathering').val()));

		res.triangle_configuration.accuracy = Math.min(1,Math.max(0,parseFloat($('#triangle_accuracy').val())));
		res.triangle_configuration.blur = Math.max(0,parseInt($('#triangle_blur').val()));
		res.triangle_configuration.threshold = Math.min(100,Math.max(0,parseInt($('#triangle_threshold').val())));

		res.triangle_configuration.vertexMode = $('#triangle_vertex_mode_dynamic').is(':checked')? true : false;
		res.triangle_configuration.vertexCount =  Math.min(50000,Math.max(0,parseInt($('#triangle_vertex_count_static').val())));
		res.triangle_configuration.vertexPercentage = Math.min(1000,Math.max(0,parseInt($('#triangle_vertex_count_dynamic').val())));

		res.triangle_configuration.fill = $('#triangle_fill_on').is(':checked')? true :
											$('#triangle_fill_off').is(':checked')? false :
											$('#triangle_fill_colorpicker').val();
		res.triangle_configuration.fillColor = $('#triangle_fill_colorpicker').val();
		res.triangle_configuration.stroke = $('#triangle_stroke_on').is(':checked')? true :
											$('#triangle_stroke_off').is(':checked')? false :
											$('#triangle_stroke_colorpicker').val();
		res.triangle_configuration.strokeColor = $('#triangle_stroke_colorpicker').val();
		res.triangle_configuration.strokeWidth = Math.max(0,parseFloat($('#triangle_stroke_width').val()));

		res.triangle_configuration.gradients = $('#triangle_gradient').is(':checked')? true : false;
		res.triangle_configuration.gradientStops = Math.min(100,Math.max(2,parseInt($('#triangle_gradient_stops').val())));
		res.triangle_configuration.lineJoin = $('#triangle_line_join').val();
		res.triangle_configuration.transparentColor = $('#triangle_transparent_color').is(':checked');

		res.whiteblacklist_configuration.mode = $("input:radio[name='wblist']:checked").val();
		let white_list = [];
		$.each($('#whitelist').val().split(/\n/), function(i, line){
			if(line){
				white_list.push(line);
			}
		});
		res.whiteblacklist_configuration.white_list = white_list;

		res.clustering_configuration.mode = Math.max(0,$('#clustering_mode').val());


		let black_list = [];
		$.each($('#blacklist').val().split(/\n/), function(i, line){
			if(line){
				black_list.push(line);
			}
		});
		res.whiteblacklist_configuration.black_list = black_list;
		browser.storage.sync.set({
			bar_configuration: res.bar_configuration,
			blur_configuration: res.blur_configuration,
			pixel_configuration: res.pixel_configuration,
			glitch_configuration: res.glitch_configuration,
			triangle_configuration: res.triangle_configuration,
			sticker_configuration: res.sticker_configuration,
			gif_configuration: res.gif_configuration,
			png_configuration: res.png_configuration,
			jpg_configuration: res.jpg_configuration,
			bmp_configuration: res.bmp_configuration,
			webp_configuration: res.webp_configuration,
			whiteblacklist_configuration: res.whiteblacklist_configuration,
			clustering_configuration: res.clustering_configuration,

		}).then(function(){
			updateOptionsContentScript();
		});

	});
});

$('button[toogle]').click(function(){
	$('#'+$(this).attr('toogle')).toggle();
	$('.'+$(this).attr('toogle')).toggle();
});

$('#radio-nolist[toogle]').click(function(){
	if($(this).is(':checked')){
		$('#whitelist-container').hide();
		$('#blacklist-container').hide();
	}
});
$('#radio-whitelist[toogle]').click(function(){
	if($(this).is(':checked')){
		$('#whitelist-container').show();
		$('#blacklist-container').hide();
	}
});
$('#radio-blacklist[toogle]').click(function(){
	if($(this).is(':checked')){
		$('#whitelist-container').hide();
		$('#blacklist-container').show();
	}
});

$('.tab').click(function(){
	$('.tab').removeClass('tab-selected');
	$(this).addClass('tab-selected');
	$('.content').removeClass('content-displayed');
	$('#'+$(this).attr('content')).addClass('content-displayed');
	browser.storage.sync.set({
		option_page_view: $(this).attr('content'),
	});
});


$('io-toggle').click(function(e){
	$(this).toggleAttr('check', true);
	$(this).children().toggleAttr('check', true);
});

$('io-toggle button').click(function(e){
	$(this).toggleAttr('check', true);
	$(this).parent().toggleAttr('check', true);
});

$('.onoff').click(function(e){
	e.stopImmediatePropagation();
	$('#onoff').html($(this).attr('check')? 'ON' : 'OFF');
	activatePuryFi($(this).attr('check')? true : false);
});

$('.labelToogle').click(function(e){
	e.stopImmediatePropagation();
	$('#'+$(this).attr('label')).toggleClass("selected", $(this).attr('check'));
	let labels = browser.storage.sync.get('labels');
	labels.then((res) => {
		let labellist = res.labels || [];
		if($(this).attr('check')){
			if(labellist.indexOf($(this).attr('label')) === -1){
				labellist.push($(this).attr('label'))
			}
		}else{
			if(labellist.indexOf($(this).attr('label')) != -1){
				labellist = removeItemAll(labellist, $(this).attr('label'));
			}
		}
		browser.storage.sync.set({
			labels: labellist
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('.overlayToogle').click(function(e){
	e.stopImmediatePropagation();
	browser.storage.sync.set({
		video_overlay: $(this).attr('check')  ? true : false
	}).then(function(){
		updateOptionsContentScript();
	});
});

$('.base64Toogle').click(function(e){
	e.stopImmediatePropagation();
	browser.storage.sync.set({
		base64_scanner: $(this).attr('check')  ? true : false
	}).then(function(){
		updateOptionsContentScript();
	});
});

$('.reverseToogle').click(function(e){
	e.stopImmediatePropagation();
	let conf = browser.storage.sync.get(['reverse_mode_configuration']);
	conf.then((res) => {
		res.reverse_mode_configuration.enabled = $(this).attr('check') ? true : false
		browser.storage.sync.set({
			reverse_mode_configuration: res.reverse_mode_configuration
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('.clusteringToogle').click(function(e){
	e.stopImmediatePropagation();
	let conf = browser.storage.sync.get(['clustering_configuration']);
	conf.then((res) => {
		res.clustering_configuration.enabled = $(this).attr('check') ? true : false
		browser.storage.sync.set({
			clustering_configuration: res.clustering_configuration
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('#reverse_censoring_process_no_results').change(function(e) {
	e.stopImmediatePropagation();
	let conf = browser.storage.sync.get(['reverse_mode_configuration']);
	conf.then((res) => {
		res.reverse_mode_configuration.process_no_result = $(this).is(':checked') ? true : false;
		browser.storage.sync.set({
			reverse_mode_configuration: res.reverse_mode_configuration
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('.filetypeToogle').click(function(e){
	e.stopImmediatePropagation();
	let file_types = browser.storage.sync.get(['file_types','gif_configuration']);
	file_types.then((res) => {
		let file_typeslist = res.file_types || [];
		if($(this).attr('check')){
			if(file_typeslist.indexOf($(this).attr('label')) === -1){
				file_typeslist.push($(this).attr('label'))
			}
		}else{
			if(file_typeslist.indexOf($(this).attr('label')) != -1){
				file_typeslist = removeItemAll(file_typeslist, $(this).attr('label'));
			}
		}
		if($('#gif-io').attr('check') && $("#gif_thumb").attr('check')){
			$('#gif_thumb').removeAttr('check');
			$('#gif_thumb_button').removeAttr('check');
			res.gif_configuration._thumbnails = false;
		}
		browser.storage.sync.set({
			file_types: file_typeslist,
			gif_configuration: res.gif_configuration,
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('#batch_converter').click(function(e){

	let file_types = browser.storage.sync.get(['file_types','gif_configuration']);
	file_types.then((res) => {
		let file_typeslist = res.file_types || [];
		$('#batch_converter_png').addClass('filetype-inactive');
		$('#batch_converter_jpg').addClass('filetype-inactive');
		$('#batch_converter_bmp').addClass('filetype-inactive');
		$('#batch_converter_webp').addClass('filetype-inactive');
		$('#batch_converter_gif').addClass('filetype-inactive');
		file_typeslist.forEach(function(type){
			$('#batch_converter_'+type).removeClass('filetype-inactive');
		});
		if(res.gif_configuration._thumbnails){
			$('#batch_converter_gif').removeClass('filetype-inactive');
		}
	});
});

$('.censormodeToogle').click(function(e){
	e.stopImmediatePropagation();
	$('button[label=normal]').removeAttr('check');
	$('button[label=normal]').parent().removeAttr('check');
	$('button[label=box]').removeAttr('check');
	$('button[label=box]').parent().removeAttr('check');
	$('button[label=black]').removeAttr('check');
	$('button[label=black]').parent().removeAttr('check');
	$('button[label=pixel]').removeAttr('check');
	$('button[label=pixel]').parent().removeAttr('check');
	$('button[label=blur]').removeAttr('check');
	$('button[label=blur]').parent().removeAttr('check');
	$('button[label=glitch]').removeAttr('check');
	$('button[label=glitch]').parent().removeAttr('check');
	$('button[label=triangle]').removeAttr('check');
	$('button[label=triangle]').parent().removeAttr('check');
	$('button[label=sticker]').removeAttr('check');
	$('button[label=sticker]').parent().removeAttr('check');
	document.getElementById("normal").classList.remove("selected");
	document.getElementById("box").classList.remove("selected");
	document.getElementById("black").classList.remove("selected");
	document.getElementById("pixel").classList.remove("selected");
	document.getElementById("blur").classList.remove("selected");
	document.getElementById("glitch").classList.remove("selected");
	document.getElementById("triangle").classList.remove("selected");
	document.getElementById("sticker").classList.remove("selected");
	$("#"+$(this).attr('label')).addClass("selected");
	$('button[label='+$(this).attr('label')+']').attr('check', true);
	$('button[label='+$(this).attr('label')+']').parent().attr('check', true);
	let censor_type = browser.storage.sync.get('censor_type');
	censor_type.then((res) => {
		let censor_type = res.censor_type || 'black';
		if($(this).attr('check')){
			censor_type = $(this).attr('label');
		}
		browser.storage.sync.set({
			censor_type: censor_type
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});


$('.debugToogle').click(function(e){
	e.stopImmediatePropagation();
	$('#'+$(this).attr('label')).toggleClass("selected", $(this).attr('check'));
	let debug = browser.storage.sync.get('debug');
	debug.then((res) => {
		let debugging = res.debug || false;
		browser.storage.sync.set({
			debug: ($(this).attr('check')? true : false)
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$('.configToogle').click(function(e){
	e.stopImmediatePropagation();
	$('#'+$(this).attr('label')).toggleClass("selected", $(this).attr('check'));
	let conf = browser.storage.sync.get(['gif_configuration','file_types']);
	conf.then((res) => {

		res.gif_configuration._thumbnails = $('#gif_thumb').attr('check')? true : false;
		if(res.gif_configuration._thumbnails){
			$('#gif-io').removeAttr('check');
			$('#gif-button').removeAttr('check');
			//$('.filetypeToogle').click();
			let file_typeslist = res.file_types || [];
			file_typeslist = removeItemAll(file_typeslist, 'gif');
			res.file_types = file_typeslist;
		}

		browser.storage.sync.set({
			gif_configuration: res.gif_configuration,
			file_types: res.file_types,
		}).then(function(){
			updateOptionsContentScript();
			if(res.gif_configuration._thumbnails) {
				//restoreFiletypes();
			}
		});

	});
});

$('.do_cacheToogle').click(function(e){
	e.stopImmediatePropagation();
	$('#'+$(this).attr('label')).toggleClass("selected", $(this).attr('check'));
	let censor = browser.storage.sync.get('do_cache');
	censor.then((res) => {
		browser.storage.sync.set({
			do_cache:  ($(this).attr('check')? true : false)
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

// jquery toggle whole attribute
$.fn.toggleAttr = function(attr, val) {
	var test = $(this).attr(attr);
	if ( test ) {
		// if attrib exists with ANY value, still remove it
		$(this).removeAttr(attr);
	} else {
		$(this).attr(attr, val);
	}
	return this;
};

// jquery toggle just the attribute value
$.fn.toggleAttrVal = function(attr, val1, val2) {
	var test = $(this).attr(attr);
	if ( test === val1) {
		$(this).attr(attr, val2);
		return this;
	}
	if ( test === val2) {
		$(this).attr(attr, val1);
		return this;
	}
	// default to val1 if neither
	$(this).attr(attr, val1);
	return this;
};

$(".labelButton").on('click', function(event){
	$(this).toggleClass("selected");
	if($(this).hasClass("selected")){
		$('button[label='+$(this).attr('id')+']').attr('check', true);
		$('button[label='+$(this).attr('id')+']').parent().attr('check', true);
	}else{
		$('button[label='+$(this).attr('id')+']').removeAttr('check');
		$('button[label='+$(this).attr('id')+']').parent().removeAttr('check');
	}
	let labels = browser.storage.sync.get('labels');
	labels.then((res) => {
		let labellist = res.labels || [];
		if($(this).hasClass("selected")){
			if(labellist.indexOf(this.id) === -1){
				labellist.push(this.id)
			}
		}else{
			if(labellist.indexOf(this.id) != -1){
				labellist = removeItemAll(labellist, this.id);
			}
		}
		browser.storage.sync.set({
			labels: labellist
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});

$(".typeButton").on('click', function(event){
	if(!$(this).hasClass("selected")){
		$('button[label=normal]').removeAttr('check');
		$('button[label=normal]').parent().removeAttr('check');
		$('button[label=box]').removeAttr('check');
		$('button[label=box]').parent().removeAttr('check');
		$('button[label=black]').removeAttr('check');
		$('button[label=black]').parent().removeAttr('check');
		$('button[label=pixel]').removeAttr('check');
		$('button[label=pixel]').parent().removeAttr('check');
		$('button[label=blur]').removeAttr('check');
		$('button[label=blur]').parent().removeAttr('check');
		$('button[label=glitch]').removeAttr('check');
		$('button[label=glitch]').parent().removeAttr('check');
		$('button[label=triangle]').removeAttr('check');
		$('button[label=triangle]').parent().removeAttr('check');
		$('button[label=sticker]').removeAttr('check');
		$('button[label=sticker]').parent().removeAttr('check');
		document.getElementById("normal").classList.remove("selected");
		document.getElementById("box").classList.remove("selected");
		document.getElementById("black").classList.remove("selected");
		document.getElementById("pixel").classList.remove("selected");
		document.getElementById("blur").classList.remove("selected");
		document.getElementById("glitch").classList.remove("selected");
		document.getElementById("triangle").classList.remove("selected");
		document.getElementById("sticker").classList.remove("selected");
		$(this).addClass("selected");

		$('button[label='+$(this).attr('id')+']').attr('check', true);
		$('button[label='+$(this).attr('id')+']').parent().attr('check', true);
		let censor_type = browser.storage.sync.get('censor_type');
		censor_type.then((res) => {
			censor_type = $(this).attr('id');
			browser.storage.sync.set({
				censor_type: censor_type
			}).then(function(){
				updateOptionsContentScript();
			});
		});

	}
});

$(".debugButton").on('click', function(event){
	if(!$(this).hasClass("selected")){
		$(this).addClass("selected");
		$('.debugToogle').attr('check', true);
	}else{
		$(this).removeClass("selected");
		$('.debugToogle').removeAttr('check');
	}
	let debug = browser.storage.sync.get('debug');
	debug.then((res) => {
		let debugging = res.debug || false;
		browser.storage.sync.set({
			debug: $(this).hasClass("selected")
		}).then(function(){
			updateOptionsContentScript();
		});
	});
});



$('#restore_default_settings-button').click(function() {
	if (window.confirm("Warning: This will reset all configurations to its default parameters.")) {
		let clearStorage = browser.storage.sync.clear();
		clearStorage.then(e => {
			resetOptions();
			window.location.reload();
		});

	}
});


